<jsp:directive.page language="java"
    contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8" />

<jsp:directive.page import="server.TakeResult" />
<jsp:directive.page import="server.SearchServlet" />
<jsp:directive.page import="server.HighlightedSearchItem" />

<%!
    public String escapeHTML(String s) {
      if (s == null) return null;
      s = s.replaceAll("&", "&amp;");
      s = s.replaceAll("<", "&lt;");
      s = s.replaceAll(">", "&gt;");
      s = s.replaceAll("\"", "&quot;");
      s = s.replaceAll("'", "&apos;");
      return s;
    }

    public String highlight(String s) {
      if (null == s) return null;
      return  s.replaceAll(
          "\\[mazko\\.github\\.io\\](.*?)\\[/mazko\\.github\\.io\\]", 
          "<b style=\"color:red;\">$1</b>");
    }
%>

<% 
    final TakeResult<HighlightedSearchItem> model = 
        (TakeResult<HighlightedSearchItem>)request
            .getAttribute("searchmodel");

    final String qDefValue = escapeHTML(request
        .getParameter(SearchServlet.QUERY_INPUT));
    final int rPerPage = request.getParameter(
        SearchServlet.RESULTS_PER_PAGE) == null ? 5 : 
            Integer.parseInt(request
                .getParameter(SearchServlet.RESULTS_PER_PAGE));
    final int cPage = request.getParameter(
        SearchServlet.CURRENT_PAGE) == null ? 1 : 
            Integer.parseInt(request
                .getParameter(SearchServlet.CURRENT_PAGE));
%>

<html>
    <head>
        <title>Lucene Highlighter Example</title>
        <meta http-equiv="Content-Type" 
              content="text/html; charset=UTF-8">
    </head>
    <body>

        <form name="search" action="/search" accept-charset="UTF-8">
            <p align="center">
                <input name="<%= SearchServlet.QUERY_INPUT %>"
                    <% if(qDefValue != null) { %>
                        value="<%= qDefValue %>"
                    <% } %>
                    size="55" style="text-align:center;"/>
            </p>
            <p align="center">
                <input name="<%= SearchServlet.RESULTS_PER_PAGE %>" 
                    size="5" value="<%= rPerPage %>"
                    style="text-align:center;" />
                &nbsp;Results Per Page&nbsp;
                <input type="submit" value="Search!"/>
            </p>
        </form>

        <% if(model != null && model.getItems() != null) { %>
            <p style="float:right;">
                 Page <b><%= cPage %></b> from <b>
                    <%= (int)Math.ceil(
                            ((float)model.totalHits) / rPerPage) 
                    %></b>
            </p>
        <% } %>

        <% if(model != null && model.getItems() != null) { %>
            <% if(cPage > 1) { %>
                <form name="search" action="/search" 
                        accept-charset="UTF-8"
                        style="float:left;">
                    <% if(qDefValue != null) { %>
                        <input type="hidden" 
                               name="<%= SearchServlet.QUERY_INPUT %>"
                               value="<%= qDefValue %>" />
                    <% } %>
                    <input type="hidden" 
                           name="<%= SearchServlet.RESULTS_PER_PAGE %>" 
                           value="<%= rPerPage %>" />
                    <input type="hidden" 
                           name= "<%= SearchServlet.CURRENT_PAGE %>" 
                           value="<%= cPage - 1 %>"/>
                    <input type="submit" 
                           value="<%= escapeHTML("<") %>"/>
                </form>
            <% } %>

            <% if(model.totalHits > cPage * rPerPage) { %>
                <form name="search" action="/search" 
                      accept-charset="UTF-8" >
                    <% if(qDefValue != null) { %>
                        <input type="hidden" 
                               name="<%= SearchServlet.QUERY_INPUT %>"
                               value="<%= qDefValue %>" />
                    <% } %>
                    <input type="hidden" 
                           name="<%= SearchServlet.RESULTS_PER_PAGE %>" 
                           value="<%= rPerPage %>" />
                    <input type="hidden" 
                           name= "<%= SearchServlet.CURRENT_PAGE %>" 
                           value="<%= cPage + 1 %>"/>
                    <input type="submit" 
                           value="<%= escapeHTML(">") %>"/>
                </form>
            <% } %>
        <% } %>

        <p align="center" style="clear:both;">
            <% if(model != null) { %>
                <% if(model.getItems() != null) { %>
                    <p>
                        <% for(HighlightedSearchItem item : 
                               model.getItems()) { %>
                            <hr/>
                            <p><b>Score: </b><%= item.score %></p>
                            <p><b>Url: </b><a href="<%= item.uri %>">
                                <%= item.uri %></a>
                            </p>
                            <p><b>Title: </b>
                                <%= highlight(
                                        escapeHTML(
                                            item.highlightedTitle)) %>
                            </p>
                            <p><b>Content: </b>
                                <%= highlight(
                                        escapeHTML(
                                            item.highlightedContent)) %>
                            </p>
                        <% } %>
                    </p>
                <% } else { %>
                    I'm sorry I couldn't find what you were looking for.
                <% } %>
            <% } %>
        </p>
        <p align="center">
            <a href="http://mazko.github.io/">http://mazko.github.io/</a>
        </p>
    </body>
</html>